VERSION 5.00
Begin VB.UserControl XPOptionCheck 
   AutoRedraw      =   -1  'True
   ClientHeight    =   435
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4470
   ClipBehavior    =   0  'None
   ControlContainer=   -1  'True
   KeyPreview      =   -1  'True
   LockControls    =   -1  'True
   ScaleHeight     =   435
   ScaleWidth      =   4470
   ToolboxBitmap   =   "XPOptionCheck.ctx":0000
End
Attribute VB_Name = "XPOptionCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*******************************************************************************************************
'********************************************
'*********************              XpOptionCheck (Part of XpControls)
'**
'*
'* Author: Jottum
'* Date  : 07/20/2007 (mm/dd/yyyy)
'* Site  : http://www.uitdeschriften.com/files/VB6/
'*
'* Feel free to use/modify this code, but:
'* - Please do not spread this code in modified form.
'* - Do not rename this control and spread its source.
'* - Leave this text where it is.
'* - Give proper credit to the author.
'*
'**
'*********************
'********************************************
'*******************************************************************************************************

Option Explicit

Private m_ForeColor As OLE_COLOR
Private mUseCustomForeColor As Boolean
Private meBackStyle As BackStyleConstants
Private mUseThemeColors As Boolean
Private meMousePointer As MousePointerConstants
Private mValue As ValueConstants
Private meUseParentFormhDC As Boolean
Private mbReadingProps As Boolean
Private mepTransparent As Boolean
Private mCaption As String
Private meTabStop As Boolean
Private mCurState As Long
Private meControlType As ControlTypes
Private bHotState As Boolean
Private bHasFocus As Boolean
Private bLeftPressed As Boolean
Private bMnemonic As Boolean
Private m_TextOffset As Long
Private h1 As Long
Private h2 As Long

Event Click()
Event DblClick()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseLeave(Button As Integer, Shift As Integer, X As Single, Y As Single)

Private WithEvents MyParent As Form
Attribute MyParent.VB_VarHelpID = -1

Private Const LF_FACESIZE = 32

Private Type FONTSLOG
  flfHeight As Long
  flfWidth As Long
  flfEscapement As Long
  flfOrientation As Long
  flfWeight As Long
  flfItalic As Byte
  flfUnderline As Byte
  flfStrikeOut As Byte
  flfCharSet As Byte
  flfOutPrecision As Byte
  flfClipPrecision As Byte
  flfQuality As Byte
  flfPitchAndFamily As Byte
  flfFaceName As String * LF_FACESIZE
End Type

Public Enum ValueConstants
   Unchecked
   Checked
   Mixed
End Enum

Public Enum ControlTypes
   CheckBox
   OptionButton
End Enum

' the constants windows uses to draw option buttons
Private Const DFC_BUTTON As Long = 4&
Private Const DFCS_BUTTONRADIO As Long = &H4&
Private Const DFCS_BUTTONCHECK = &H0
Private Const DFCS_CHECKED As Long = &H400&
Private Const DFCS_INACTIVE = &H100
Private Const DFCS_HOT = &H1000
Private Const DFCS_PUSHED = &H200
  
Private Declare Function DrawFrameControl Lib "user32" (ByVal hDC&, lpRect As RECT, ByVal un1&, ByVal un2&) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal xDest As Long, ByVal yDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hDC As Long, lpRect As RECT) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function GetSysColorBrush Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function OleTranslateColor Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, ByVal HPALETTE As Long, pccolorref As Long) As Long
Private Const CLR_INVALID = -1
Private Const CLR_NONE = CLR_INVALID

'------------------------------------------------------

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" ( _
    ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" ( _
   ByVal hLibModule As Long) As Long
   
Private m_hMod As Long

Private Const SW_HIDE = 0
Private Const SW_SHOW = 5

Private Const WM_NOTIFY = &H4E
Private Const WM_MOUSEMOVE = &H200

Private Type DTBGOPTS
    dwSize As Long
    dwFlags As Long
    rcClip As RECT
End Type

Private Type Margins
    cxLeftWidth As Long
    cxRightWidth As Long
    cyTopHeight As Long
    cyBottomHeight As Long
End Type

Private Type NMHDR
    hWndFrom As Long
    idFrom As Long
    Code As Long
End Type
   
Private Type SIZE
   cx As Long
   cy As Long
End Type
   
Private Declare Function OpenThemeData Lib "uxtheme.dll" _
   (ByVal hWnd As Long, ByVal pszClassList As Long) As Long

Private Declare Function CloseThemeData Lib "uxtheme.dll" _
   (ByVal hTheme As Long) As Long

Private Declare Function GetThemeColor Lib "uxtheme.dll" _
   (ByVal hTheme As Long, _
    ByVal iPartId As Long, _
    ByVal iStateId As Long, _
    ByVal iPropId As Long, _
    ByRef pColor As OLE_COLOR) As Long
                 
Private Declare Function DrawThemeText Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, _
    ByVal iStateId As Long, ByVal pszText As Long, _
    ByVal iCharCount As Long, ByVal dwTextFlag As Long, _
    ByVal dwTextFlags2 As Long, pRect As RECT) As Long
    
Private Declare Function DrawThemeEdge Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, _
    ByVal iStateId As Long, pDestRect As RECT, _
    ByVal uEdge As Long, ByVal uFlags As Long, _
    pContentRect As RECT) As Long
    
Private Declare Function DrawThemeBackgroundEx Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pDtgBopts As DTBGOPTS) As Long
    
Private Declare Function DrawThemeBackground Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pClipRect As RECT) As Long
    
Private Declare Function GetCurrentThemeName Lib "uxtheme.dll" _
   (ByVal pszThemeFileName As Long, _
    ByVal dwMaxNameChars As Long, _
    ByVal pszColorBuff As Long, _
    ByVal cchMaxColorChars As Long, _
    ByVal pszSizeBuff As Long, _
    ByVal cchMaxSizeChars As Long) As Long
   
Private Declare Function GetThemeRect Lib "uxtheme.dll" _
   (ByVal hTheme As Long, _
    ByVal iPartId As Long, _
    ByVal iStateId As Long, _
    ByVal iPropId As Long, _
    ByRef pRect As RECT) As Long
   
Private Declare Function GetThemeBackgroundContentRect Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pClipRect As RECT) As Long
   
Private Declare Function GetThemeBackgroundExtent Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pClipRect As RECT) As Long
   
Private Declare Function GetThemeMargins Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pMargins As Margins) As Long
   
Private Declare Function GetThemeFont Lib "uxtheme.dll" _
   (ByVal hTheme As Long, _
    ByVal hDC As Long, _
    ByVal iPartId As Long, _
    ByVal iStateId As Long, _
    ByVal iPropId As Long, _
    tLogFont As FONTSLOG) As Long
    
Private Declare Function GetThemeSysFont Lib "uxtheme.dll" _
   (hTheme As Long, _
    iFontID As Long, _
    tLogFont As LOGFONT) As Long
   
Private Declare Function GetThemePartSize Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, _
   ByVal iStateId As Long, prc As RECT, ByVal eSize As THEMESIZE, _
   psz As SIZE) As Long

Private Const DT_LEFT = &H0
Private Const DT_TOP = &H0
Private Const DT_CENTER = &H1
Private Const DT_RIGHT = &H2
Private Const DT_VCENTER = &H4
Private Const DT_BOTTOM = &H8&
Private Const DT_SINGLELINE = &H20
Private Const BP_PUSHBUTTON = 1
Private Const BP_RADIOBUTTON = 2
Private Const BP_CHECKBOX = 3
Private Const BP_GROUPBOX = 4
Private Const BP_USERBUTTON = 5

Private Const PBS_NORMAL = 1
Private Const PBS_HOT = 2
Private Const PBS_PRESSED = 3
Private Const PBS_DISABLED = 4
Private Const PBS_DEFAULTED = 5
Private Const TMT_FONT = 210

Private Const EP_EDITTEXT = 1
Private Const ETS_NORMAL = 1
Private Const ETS_DISABLED = 4

Private Const PP_BAR = 1
Private Const PP_NORMAL = 1

Private Const CBS_UNCHECKEDNORMAL = 1
Private Const CBS_UNCHECKEDHOT = 2
Private Const CBS_UNCHECKEDPRESSED = 3
Private Const CBS_UNCHECKEDDISABLED = 4
Private Const CBS_CHECKEDNORMAL = 5
Private Const CBS_CHECKEDHOT = 6
Private Const CBS_CHECKEDPRESSED = 7
Private Const CBS_CHECKEDDISABLED = 8
Private Const CBS_MIXEDNORMAL = 9
Private Const CBS_MIXEDHOT = 10
Private Const CBS_MIXEDPRESSED = 11
Private Const CBS_MIXEDDISABLED = 12

'
Const m_def_BackStyle = 0 'Transparent

Public Property Get ControlType() As ControlTypes
Attribute ControlType.VB_Description = "Switch between CheckBox and OptionButton."
   ControlType = meControlType
End Property

Public Property Let ControlType(ByVal Setting As ControlTypes)
   meControlType = Setting
   RepaintControl
   PropertyChanged "ControlType"
End Property

Public Property Get UseParentFormhDC() As Boolean
Attribute UseParentFormhDC.VB_Description = "Use Parent as a source for the transparency regardless whether the control is contained by another control. This can be useful when working with a vbTabStrip for example when you're using DrawTabStripCheat."
   UseParentFormhDC = meUseParentFormhDC
End Property

Public Property Let UseParentFormhDC(ByVal Setting As Boolean)
   meUseParentFormhDC = Setting
   PropertyChanged "UseParentFormhDC"
End Property

Public Property Get UseCustomForeColor() As Boolean
Attribute UseCustomForeColor.VB_Description = "By default, current system/Theme colors are used. Set this value to True to use a custom ForeColor."
   UseCustomForeColor = mUseCustomForeColor
End Property

Public Property Let UseCustomForeColor(ByVal Setting As Boolean)
   mUseCustomForeColor = Setting
   PropertyChanged "UseCustomForeColor"
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Although displayed, the default theme or Windows 3D colors are used."
   BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal Setting As OLE_COLOR)
   UserControl.BackColor() = Setting
   RepaintControl
   PropertyChanged "BackColor"
End Property

Public Property Get BackStyle() As BackStyleConstants
Attribute BackStyle.VB_Description = "Transparent will show what's behind the control, Opaque has the default vbButtonFace color."
   BackStyle = meBackStyle
End Property

Public Property Let BackStyle(ByVal Setting As BackStyleConstants)
   meBackStyle = Setting
   RepaintControl
   PropertyChanged "BackStyle"
End Property

Public Property Get Themed() As Boolean
Attribute Themed.VB_Description = "Use the current theme colors, instead of legacy 3D colors."
   Themed = mUseThemeColors
End Property

Public Property Let Themed(ByVal Setting As Boolean)
   mUseThemeColors = Setting
   Redraw
   PropertyChanged "Themed"
End Property

Public Property Get ForeColor() As OLE_COLOR
   ForeColor = UserControl.ForeColor
   m_ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal Setting As OLE_COLOR)
   UserControl.ForeColor() = Setting
   m_ForeColor = Setting
   RepaintControl
   PropertyChanged "ForeColor"
End Property

Public Property Get Enabled() As Boolean
   Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal Setting As Boolean)

   UserControl.Enabled() = Setting

   If Setting = False Then
   
      If mValue = Checked Then
   
         mCurState = CBS_CHECKEDDISABLED
         
      ElseIf mValue = Unchecked Then
      
         mCurState = CBS_UNCHECKEDDISABLED
         
      ElseIf mValue = Mixed Then
      
         mCurState = CBS_MIXEDDISABLED
      
      End If
      
      UserControl.ForeColor = vbGrayText '(Un)Comment to show/hide caption in Disabled state
                                         'as well.
   Else
   
      If mValue = Checked Then
   
         mCurState = CBS_CHECKEDNORMAL
         
      ElseIf mValue = Unchecked Then
      
         mCurState = CBS_UNCHECKEDNORMAL
      
      ElseIf mValue = Mixed Then
      
         mCurState = CBS_MIXEDNORMAL
      
      End If
      
      UserControl.ForeColor = m_ForeColor '(Un)Comment to show/hide caption in Disabled state
                                          'as well.
   End If
      
   RepaintControl
   
   PropertyChanged "Enabled"
   
End Property

Public Property Get Value() As ValueConstants
Attribute Value.VB_Description = "Set the initial value, 0 for unchecked, 1 for checked and 2 for mixed state."
   Value = mValue
End Property

Public Property Let Value(ByVal Setting As ValueConstants)

   mValue = Setting
   
   If UserControl.Enabled Then
   
      If Setting = Checked Then
      
         mCurState = CBS_CHECKEDNORMAL
         
      ElseIf Setting = Unchecked Then
      
         mCurState = CBS_UNCHECKEDNORMAL
         
      ElseIf Setting = Mixed Then
      
         mCurState = CBS_MIXEDNORMAL
         
      End If
      
   Else
   
      If Setting = Checked Then
      
         mCurState = CBS_CHECKEDDISABLED
         
      ElseIf Setting = Unchecked Then
      
         mCurState = CBS_UNCHECKEDDISABLED
         
      ElseIf Setting = Mixed Then
      
         mCurState = CBS_MIXEDDISABLED
         
      End If
      
   End If
   
   RepaintControl
   PropertyChanged "Value"
   
End Property

Public Property Get Font() As Font
   Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal Setting As Font)
   Set UserControl.Font = Setting
   RepaintControl
   PropertyChanged "Font"
End Property

Private Sub UserControl_Click()
   RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
   RaiseEvent DblClick
End Sub

Private Sub UserControl_GotFocus()
   bHasFocus = True
   RepaintControl 'Draw the FocusRect.
End Sub

Private Sub UserControl_LostFocus()
   bHasFocus = False
   RepaintControl 'Wipe the FocusRect.
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
      
   If Button = vbLeftButton Then
         
      bLeftPressed = True
         
      If meControlType = OptionButton Then
         
         Select Case mCurState
         
            Case CBS_UNCHECKEDHOT
            
               mCurState = CBS_UNCHECKEDPRESSED
               
            Case CBS_CHECKEDHOT
            
               mCurState = CBS_CHECKEDPRESSED
               
            Case CBS_MIXEDHOT
            
               mCurState = CBS_MIXEDPRESSED
               
         End Select
            
         ReseToptionButtons
         
      Else
      
         Select Case mCurState
         
            Case CBS_UNCHECKEDHOT
            
               mCurState = CBS_UNCHECKEDPRESSED
               
            Case CBS_CHECKEDHOT
            
               mCurState = CBS_CHECKEDPRESSED
               
            Case CBS_MIXEDHOT
            
               mCurState = CBS_MIXEDPRESSED
               
         End Select
      
      End If
      
      RepaintControl
      
      RaiseEvent MouseDown(Button, Shift, X, Y)
      
   End If
  
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If ((X < 0) Or (X > UserControl.ScaleWidth) Or (Y < 0) Or (Y > UserControl.ScaleHeight)) Then 'MouseLeave
         'Mouse Leave
         
         Select Case mCurState
      
            Case CBS_CHECKEDHOT
               mCurState = CBS_CHECKEDNORMAL
      
            Case CBS_CHECKEDPRESSED
               mCurState = CBS_CHECKEDNORMAL
      
            Case CBS_UNCHECKEDHOT
               mCurState = CBS_UNCHECKEDNORMAL
      
            Case CBS_UNCHECKEDPRESSED
               mCurState = CBS_UNCHECKEDNORMAL
      
            Case CBS_MIXEDHOT
               mCurState = CBS_MIXEDNORMAL
      
            Case CBS_MIXEDPRESSED
               mCurState = CBS_UNCHECKEDNORMAL 'Not sure if right Const.
      
         End Select
         
         RepaintControl
         Call ReleaseCapture
         RaiseEvent MouseLeave(Button, Shift, X, Y)
         
    ElseIf ((X > 0) Or (X < UserControl.ScaleWidth) Or (Y > 0) Or (Y < UserControl.ScaleHeight)) Then
    
      Select Case mCurState
      
         Case CBS_UNCHECKEDNORMAL
         
            mCurState = CBS_UNCHECKEDHOT
      
         Case CBS_CHECKEDNORMAL
         
            mCurState = CBS_CHECKEDHOT
      
         Case CBS_MIXEDNORMAL
         
            mCurState = CBS_MIXEDHOT
      
      End Select
         
      RepaintControl
    
      If GetCapture <> UserControl.hWnd Then 'MouseEnter
         
         Call SetCapture(UserControl.hWnd)

      End If
      
      RaiseEvent MouseMove(Button, Shift, X, Y)
               
    End If

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
   
   If Button = vbLeftButton Then
   
      If meControlType = OptionButton Then
   
         Select Case mCurState
         
            Case CBS_UNCHECKEDPRESSED
            
               mCurState = CBS_CHECKEDHOT
               
               mValue = Checked
               
            Case CBS_CHECKEDPRESSED
            
               mCurState = CBS_CHECKEDHOT
               
               mValue = Checked
                              
         End Select
      
      Else
      
         Select Case mCurState
         
            Case CBS_UNCHECKEDPRESSED
            
               mCurState = CBS_CHECKEDHOT
               
               mValue = Checked
               
            Case CBS_CHECKEDPRESSED
            
               mCurState = CBS_UNCHECKEDHOT
               
               mValue = Unchecked
               
            Case CBS_MIXEDPRESSED
            
               mCurState = CBS_UNCHECKEDHOT
               
               mValue = Unchecked
               
         End Select
      
      End If
      
      RepaintControl
   
      RaiseEvent MouseUp(Button, Shift, X, Y)
      
      bLeftPressed = False
      
   End If
   
End Sub

Private Sub UserControl_Initialize()

   mUseThemeColors = True
   m_hMod = LoadLibrary("shell32.dll")
   
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
   
   Set UserControl.Font = Ambient.Font
   Caption = Ambient.DisplayName
   meBackStyle = Transparent
   
End Sub

Private Sub UserControl_Paint()
   RepaintControl
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropertiesBag As PropertyBag)
Dim sFontString As String
   
   With PropertiesBag
      BackColor = .ReadProperty("BackColor", vbButtonFace)
      ForeColor = .ReadProperty("ForeColor", vbButtonText)
      mUseThemeColors = .ReadProperty("Themed", True)
      mUseCustomForeColor = .ReadProperty("UseCustomForeColor", False)
      meBackStyle = .ReadProperty("BackStyle", Transparent)
      meUseParentFormhDC = .ReadProperty("UseParentFormhDC", False)
      Enabled = .ReadProperty("Enabled", True)
      mValue = .ReadProperty("Value", 0)
      Set UserControl.Font = .ReadProperty("Font", Ambient.Font)
      Caption = .ReadProperty("Caption", Ambient.DisplayName)
      FontUnderline = .ReadProperty("FontUnderline", False)
      FontTransparent = .ReadProperty("FontTransparent", True)
      FontStrikethru = .ReadProperty("FontStrikethru", False)
      FontSize = .ReadProperty("FontSize", 8.25)
      FontName = .ReadProperty("FontName", "MS Sans Serif")
      FontItalic = .ReadProperty("FontItalic", False)
      FontBold = .ReadProperty("FontBold", False)
      Set MouseIcon = .ReadProperty("MouseIcon", Nothing)
      MousePointer = .ReadProperty("MousePointer", vbDefault)
      meControlType = .ReadProperty("ControlType", 0)
      meTabStop = .ReadProperty("TabStop", meTabStop)
   End With
   
   If Ambient.UserMode Then
   
      Set MyParent = UserControl.Parent
      
   End If
      
   If mValue = 0 Then
   
      mCurState = CBS_UNCHECKEDNORMAL
      
   End If

   If UserControl.Enabled = False Then
   
      If mValue = Checked Then
   
         mCurState = CBS_CHECKEDDISABLED
         
      ElseIf mValue = Unchecked Then
      
         mCurState = CBS_UNCHECKEDDISABLED
      
      ElseIf mValue = Mixed Then
      
         mCurState = CBS_MIXEDDISABLED
      
      End If
         
      UserControl.ForeColor = vbGrayText '(Un)Comment to show/hide caption in Disabled state
                                          'as well.
   Else
   
      If mValue = Checked Then
   
         mCurState = CBS_CHECKEDNORMAL
         
      ElseIf mValue = Unchecked Then
      
         mCurState = CBS_UNCHECKEDNORMAL
         
      ElseIf mValue = Mixed Then
      
         mCurState = CBS_MIXEDNORMAL
         
      End If
   
      UserControl.ForeColor = m_ForeColor '(Un)Comment to show/hide caption in Disabled state
                                          'as well.
   End If
     
   If mUseThemeColors Then
   
      On Error Resume Next
      Set UserControl.Font.Name = ThemeSysFont
      UserControl.FontName = ThemeSysFont
      On Error GoTo 0
      
   End If
   
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropertiesBag As PropertyBag)

   With PropertiesBag
      .WriteProperty "BackColor", UserControl.BackColor, &H8000000F
      .WriteProperty "BackStyle", meBackStyle, Transparent
      .WriteProperty "UseParentFormhDC", meUseParentFormhDC, False
      .WriteProperty "UseCustomForeColor", mUseCustomForeColor, False
      .WriteProperty "ForeColor", UserControl.ForeColor, &H80000012
      .WriteProperty "Enabled", UserControl.Enabled, True
      .WriteProperty "Themed", mUseThemeColors, True
      .WriteProperty "Value", mValue, 0
      .WriteProperty "Font", UserControl.Font, Ambient.Font
      .WriteProperty "Caption", mCaption, Ambient.DisplayName
      .WriteProperty "FontUnderline", UserControl.FontUnderline, False
      .WriteProperty "FontTransparent", UserControl.FontTransparent, True
      .WriteProperty "FontStrikethru", UserControl.FontStrikethru, False
      .WriteProperty "FontSize", UserControl.FontSize, False
      .WriteProperty "FontName", UserControl.FontName, "MS Sans Serif"
      .WriteProperty "FontItalic", UserControl.FontItalic, False
      .WriteProperty "FontBold", UserControl.FontBold, False
      .WriteProperty "MouseIcon", MouseIcon, Nothing
      .WriteProperty "MousePointer", UserControl.MousePointer, vbDefault
      .WriteProperty "ControlType", meControlType, 0
      .WriteProperty "TabStop", meTabStop, False
   End With

End Sub

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Set the Caption for XpOptionCheck."
   Caption = mCaption
End Property

Public Property Let Caption(ByVal Setting As String)
   If InStrB(Setting, "&") <> 0 Then
      bMnemonic = True
   Else
      bMnemonic = False
   End If
   mCaption = Setting
   RepaintControl
   PropertyChanged "Caption"
End Property

Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_MemberFlags = "400"
   FontUnderline = UserControl.FontUnderline
End Property

Public Property Let FontUnderline(ByVal Setting As Boolean)
   UserControl.FontUnderline = Setting
   RepaintControl
   PropertyChanged "FontUnderline"
End Property

Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_MemberFlags = "400"
   FontStrikethru = UserControl.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal Setting As Boolean)
   UserControl.FontStrikethru = Setting
   RepaintControl
   PropertyChanged "FontStrikethru"
End Property

Public Property Get FontSize() As Single
Attribute FontSize.VB_MemberFlags = "400"
   FontSize = UserControl.FontSize
End Property

Public Property Let FontSize(ByVal Setting As Single)
   UserControl.FontSize = Setting
   RepaintControl
   PropertyChanged "FontSize"
End Property

Public Property Get FontName() As String
Attribute FontName.VB_MemberFlags = "400"
   FontName = UserControl.FontName
End Property

Public Property Let FontName(ByVal Setting As String)
   UserControl.FontName = Setting
   RepaintControl
   PropertyChanged "FontName"
End Property

Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_MemberFlags = "400"
   FontItalic = UserControl.FontItalic
End Property

Public Property Let FontItalic(ByVal Setting As Boolean)
   UserControl.FontItalic = Setting
   RepaintControl
   PropertyChanged "FontItalic"
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_MemberFlags = "400"
   FontBold = UserControl.FontBold
End Property

Public Property Let FontBold(ByVal Setting As Boolean)
   UserControl.FontBold = Setting
   RepaintControl
   PropertyChanged "FontBold"
End Property

Public Property Get hWnd() As Long
   hWnd = UserControl.hWnd
End Property

Public Property Get hDC() As Long
   hDC = UserControl.hDC
End Property

Public Property Get TabStop() As Boolean
   TabStop = meTabStop
End Property

Public Property Let TabStop(ByVal Setting As Boolean)
   meTabStop = Setting
   PropertyChanged "TabStop"
End Property

Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Select a user mouse icon."
   Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal Setting As Picture)
   Set UserControl.MouseIcon = Setting
   PropertyChanged "MouseIcon"
End Property

Public Property Get MousePointer() As MousePointerConstants
   MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal Setting As MousePointerConstants)
Attribute MousePointer.VB_Description = "Select a pointer from the dropdown."
   meMousePointer = Setting
   UserControl.MousePointer = meMousePointer
   PropertyChanged "MousePointer"
End Property

Private Sub UserControl_Resize()
   RepaintControl
End Sub

Private Sub UserControl_Show()
   RepaintControl
End Sub

Private Sub UserControl_Terminate()
   FreeLibrary m_hMod
End Sub

Private Sub Redraw(Optional dState As Long = -1)

   Dim tR As RECT
   Dim tR2 As RECT
   Dim tR3 As RECT
   Dim tSize As SIZE
   Dim tTextR As RECT
   Dim hTheme As Long
   Dim cControlKind As Long
   Dim lFlags As Long
   Dim lHdc As Long
   Dim tLogFont As FONTSLOG
   Dim lR As Long
   
   lHdc = UserControl.hDC
   
   If dState = -1 Then

      dState = mCurState

   End If

   If IsThemed(UserControl.hWnd) And mUseThemeColors Then  'Draw themed control.
                           
      If Not UserControl.Enabled Then

         If mValue = Checked Then

            dState = CBS_CHECKEDDISABLED

         ElseIf mValue = Unchecked Then

            dState = CBS_UNCHECKEDDISABLED

         ElseIf mValue = Mixed Then

            dState = CBS_MIXEDDISABLED

         End If

      End If
            
      hTheme = OpenThemeData(UserControl.hWnd, StrPtr(ClassListItems.PSZ_BUTTON))
      
      If meControlType = OptionButton Then
      
         cControlKind = BP_RADIOBUTTON
         
      Else
      
         cControlKind = BP_CHECKBOX
      
      End If
                     
      tR.Top = ScaleY(UserControl.Height / 2, vbTwips, vbPixels) - (ScaleY(UserControl.TextHeight("T") / 2, vbTwips, vbPixels))
      tR.Left = 0
      
      lR = GetThemePartSize(hTheme, UserControl.hDC, cControlKind, dState, tR, TS_TRUE, tSize)
         
      tR.Right = tR.Left + tSize.cx
      tR.Bottom = tR.Top + tSize.cy
              
      DrawThemeBackground hTheme, UserControl.hDC, _
         cControlKind, _
         dState, _
         tR, tR
      
      tR.Top = ScaleY((UserControl.Height / 2), vbTwips, vbPixels) - ScaleY((UserControl.TextHeight("F") / 2), vbTwips, vbPixels)
      tR.Left = tR.Right + 4 'ScaleX(255, vbTwips, vbPixels) 'Start Caption 3 pixels from checkbox.
      tR.Right = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels) + tR.Left
      tR.Bottom = ScaleY(UserControl.Height, vbTwips, vbPixels) - tR.Top
      
      If mUseCustomForeColor Then
      
         DrawText UserControl.hDC, mCaption, Len(mCaption), tR, DT_LEFT
      
      Else
            
         DrawThemeText hTheme, _
                       UserControl.hDC, _
                       cControlKind, _
                       dState, _
                       StrPtr(mCaption), _
                       -1, _
                       DT_SINGLELINE Or DT_LEFT, _
                       0, _
                       tR
      
      End If
      
      CloseThemeData hTheme
      
      If bHasFocus And UserControl.Enabled Then
      
         DrawDottedRect
         
      End If
         
   Else 'Fall back on legacy Windows controls.
      
      If UserControl.Enabled = False Then
         
         If meControlType = OptionButton Then
      
            If mValue = Checked Then
         
               lFlags = DFCS_BUTTONRADIO Or DFCS_CHECKED Or DFCS_INACTIVE
               
            Else
            
               lFlags = DFCS_BUTTONRADIO Or DFCS_INACTIVE
            
            End If
            
         Else
         
            If mValue = Checked Then
         
               lFlags = DFCS_BUTTONCHECK Or DFCS_CHECKED Or DFCS_INACTIVE
               
            Else
            
               lFlags = DFCS_BUTTONCHECK Or DFCS_INACTIVE
            
            End If
         
         End If
         
      Else
      
         If meControlType = OptionButton Then
      
            If mValue = Checked Then
         
               lFlags = DFCS_BUTTONRADIO Or DFCS_CHECKED
               
            Else
            
               lFlags = DFCS_BUTTONRADIO
            
            End If
            
         Else
         
            If mValue = Checked Then
         
               lFlags = DFCS_BUTTONCHECK Or DFCS_CHECKED
               
            Else
            
               lFlags = DFCS_BUTTONCHECK
            
            End If
         
         End If
         
      End If
   
      Select Case dState
      
         Case CBS_UNCHECKEDHOT, CBS_CHECKEDHOT, CBS_MIXEDHOT
         
            lFlags = lFlags Or DFCS_HOT 'Only works on Vista!!
            
         Case CBS_UNCHECKEDPRESSED, CBS_CHECKEDPRESSED, CBS_MIXEDPRESSED
         
            lFlags = lFlags Or DFCS_PUSHED
            
      End Select
         
      tR.Top = ScaleY(UserControl.Height / 2, vbTwips, vbPixels) - (ScaleY(UserControl.TextHeight("T") / 2, vbTwips, vbPixels))
      tR.Left = 0
      tR.Right = ScaleX(210, vbTwips, vbPixels)
      tR.Bottom = ScaleY(UserControl.Height, vbTwips, vbPixels) - tR.Top

      DrawFrameControl UserControl.hDC, tR, DFC_BUTTON, lFlags
      
      tR.Top = ScaleY((UserControl.Height / 2), vbTwips, vbPixels) - ScaleY((UserControl.TextHeight("F") / 2), vbTwips, vbPixels)
      tR.Left = ScaleX(255, vbTwips, vbPixels) 'Start Caption 3 pixels from checkbox.
      tR.Right = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels) + ScaleX(255, vbTwips, vbPixels)
      
      DrawText UserControl.hDC, mCaption, Len(mCaption), tR, vbButtonText
      
      If bHasFocus And UserControl.Enabled Then
      
         DrawDottedRect
         
      End If
      
   End If
      
End Sub

Private Sub DrawDottedRect()

   Dim tR As RECT
   
   tR.Top = 1
   tR.Left = m_TextOffset - 2
   tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels)
   tR.Bottom = ScaleY(UserControl.Height, vbTwips, vbPixels) - 1
   
   DrawFocusRect UserControl.hDC, tR

End Sub

Private Sub ReseToptionButtons()

   Dim ctl As Control

   For Each ctl In UserControl.Parent.Controls
      
      If TypeOf ctl Is XPOptionCheck Then
         
         If ctl.Container.hWnd = UserControl.ContainerHwnd Then
            
            If ctl.hWnd <> UserControl.hWnd Then
            
               If ctl.ControlType = OptionButton Then
               
                  If ctl.Value = 1 Then
                  
                     ctl.Value = 0
                     
                  End If
               
               End If
               
            End If
            
         End If
         
      End If
      
   Next
      
End Sub

   '*************************************************************************
   '* This function is written by GumbyTheCat and used with his permission. *
   '*************************************************************************

Private Sub MakeContainerTransparent()

   '*************************************************************************
   '* displays what's behind the container control, thereby effectively     *
   '* rendering the container Transparent.                                  *
   '*************************************************************************

   On Error Resume Next

   Dim pX               As Long, pY As Long, r As Long
   Dim ctl              As Control
   Dim rc               As RECT

   h2 = UserControl.hDC               ' the dc of this control.
   
   If Not meUseParentFormhDC Then ' Added by Jottum
   
      If UserControl.Parent.hWnd = UserControl.ContainerHwnd Then
         'the container resides on a Form, so use parent hDC.
         UserControl.Parent.AutoRedraw = True ' added by mru
         h1 = UserControl.Parent.hDC
      Else
         'the container resides in another container, so use parent container's hDC.
         For Each ctl In UserControl.Parent.Controls
         'find container.
            If ctl.hWnd = UserControl.ContainerHwnd Then 'Found our container
               ctl.AutoRedraw = True 'AutoRedraw must be True
               h1 = ctl.hDC 'Get the containers hDC
               Exit For
            End If
         Next
      End If
   
   '  get offsets for BitBlt.
      If UserControl.Extender.Container.ScaleMode = vbTwips Then
         pX = UserControl.Extender.Left \ Screen.TwipsPerPixelX
         pY = UserControl.Extender.Top \ Screen.TwipsPerPixelY
      Else
         pX = UserControl.Extender.Left
         pY = UserControl.Extender.Top
      End If
   
   Else
   
      UserControl.Extender.Parent.AutoRedraw = True ' Added by Jottum
      h1 = UserControl.Extender.Parent.hDC
      
      pGetClientRect rc
      pX = rc.Left
      pY = rc.Top
      
   End If
   
'  copy background to our usercontrol hDC.
   r = BitBlt(h2, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, h1, pX, pY, vbSrcCopy)

End Sub

Private Sub RepaintControl()

   Dim tR2 As RECT
   Dim tR As RECT
   Dim hBrush As Long
   Dim m_BackColor As OLE_COLOR
   Dim tSize As SIZE
   Dim lR As Long
   Dim cControlKind As Long
   Dim hTheme As Long

   If meControlType = OptionButton Then
      cControlKind = BP_RADIOBUTTON
   Else
      cControlKind = BP_CHECKBOX
   End If
   
   m_BackColor = UserControl.BackColor

   UserControl.Height = UserControl.TextHeight("T") + ScaleY(4, vbPixels, vbTwips)
   
   If IsThemed() Then
      hTheme = OpenThemeData(UserControl.hWnd, StrPtr("Button"))
      lR = GetThemePartSize(hTheme, UserControl.hDC, cControlKind, mCurState, tR, TS_TRUE, tSize)
      
      tR.Left = 0
      tR.Right = tR2.Left + tSize.cx
      m_TextOffset = tR.Right + 5
   Else
      tR.Left = 0
      tR.Right = tR2.Left + ScaleX(210, vbTwips, vbPixels)
      m_TextOffset = tR.Right + 5
   End If
   
   If bMnemonic Then
      UserControl.Width = UserControl.TextWidth(mCaption) + ScaleX(m_TextOffset, vbPixels, vbTwips) - UserControl.TextWidth("&")
   Else
      UserControl.Width = UserControl.TextWidth(mCaption) + ScaleX(m_TextOffset, vbPixels, vbTwips)
   End If
   
   CloseThemeData hTheme

   GetClientRect Me.hWnd, tR2
   
   If (m_BackColor And &H80000000) Then
      hBrush = GetSysColorBrush(m_BackColor And &H1F&)
   Else
      hBrush = CreateSolidBrush(TranslateColor(m_BackColor))
   End If
   
   FillRect UserControl.hDC, tR2, hBrush
   DeleteObject hBrush

   If meBackStyle = Transparent Then
         
      MakeContainerTransparent
      
   End If
            
   Redraw mCurState

End Sub

Public Sub MyParent_Resize()

   RepaintControl

End Sub

Public Sub MyParent_Paint()

   RepaintControl

End Sub

Public Sub Refresh()

   RepaintControl
   UserControl.Refresh
   
End Sub

'Code by vbAccelerator.com
Private Sub pGetClientRect(rc As RECT)
Dim tP As POINTAPI
    ' Get window rect of the user control:
    GetWindowRect UserControl.hWnd, rc
    tP.X = rc.Left
    tP.Y = rc.Top
    ' Adjust to coordinates of user control's container:
    ScreenToClient UserControl.Parent.hWnd, tP
    rc.Right = rc.Right + (tP.X - rc.Left)
    rc.Bottom = rc.Bottom + (tP.Y - rc.Top)
    rc.Left = tP.X
    rc.Top = tP.Y
End Sub

'Code by vbAccelerator.com
Private Function TranslateColor(ByVal oClr As OLE_COLOR, _
                        Optional hPal As Long = 0) As Long
    ' Convert Automation color to Windows color
    If OleTranslateColor(oClr, hPal, TranslateColor) Then
        TranslateColor = CLR_INVALID
    End If
End Function


